#lang racket

(require "mauxb.rkt")

;;;; 12. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 10.5.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované príprave na semestrálny test:
;;;; - kombinatorika na zoznamoch,
;;;; - primitívne rekurzívne indexy,
;;;; - imperatívne programovanie.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory maux*.rkt obsahujú definície pomocných funkcií a predikátov. 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;; Pozri tiež súbor priprava_na_test.txt

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Zopakovanie.

(define (each? p? xs)
  (if (null? xs) #t (and (p? (car xs)) (each? p? (cdr xs)))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;;; Kapitola. Primitívne rekurzívne funkcie.

;;; Sekcia. Univerzálna funkcia pre primitívne rekurzívne funkcie.

;;; Podsekcia. Aritmetizácia primitívne rekurzívnych funkčných symbolov.

;; [Lisp] Pozri modul v súbore mauxb.rkt.

;;; Podsekcia. Interpreter primitívne rekurzívnych funkčných symbolov.

;; [Lisp] Pozri modul v súbore mauxb.rkt.

;; Podsekcia. Primitívne rekurzívne indexy.

;; Definícia. Ak platí predikát p.r.-function-symbol?(n,e), tak vravíme, že
;; číslo e je dobre vytvorený primitívne rekurzívny index n-árnej primitívne
;; rekurzívnej funkcie.

;;; Podsekcia. Efektívne operácie na primitívne rekurzívnych indexoch.

;;; Podpodsekcia. Konštantné funkcie.

;; Príklad z minulého cvičenia.
;; Program pre funkciu xc1(m) takú, že platí:
;;   p.r.-function-symbol?(1,xc1(m))
;;   interpreter(xc1(m),x) = m

(define (xc1 m) ...)

;; (PRFS? (xc1 5))
;; (p.r.-function-symbol? 1 (xc1 5))
;; (query (λ (x) (interpreter (xc1 5) x)) 0 10)

;; (query (λ (m) (PRFS? (xc1 m))) 0 10)
;; (query (λ (m) (p.r.-function-symbol? 1 (xc1 m))) 0 10)

;; Príklad z minulého cvičenia.
;; Program pre funkciu xc2(n,m) takú, že platí:
;;   p.r.-function-symbol?(n,xc2(n,m))
;;   interpreter(xc2(n,m),<x₁,...,xₙ>) = m

(define (xc2 n m) ...)

;; (PRFS? (xc2 3 5))
;; (p.r.-function-symbol? 3 (xc2 3 5))
;; (query (λ (x) (interpreter (xc2 3 5) (cons x (cons x x)))) 0 10)

;; (query (λ (n) (PRFS? (xc2 n 5))) 1 10)
;; (query (λ (n) (p.r.-function-symbol? n (xc2 n 5))) 1 10)

;;; Podsekcia. Explicitné definície.

;;; Podpodsekcia. Aritmetizácia primitívne rekurzívnych termov.

;; Konštruktory.

(define (Vt i) (list 'Vt i))       ; premenné
(define (Ct m) (list 'Ct m))       ; konštanty
(define (Pt t ts) (list 'Pt t ts)) ; kontrakcia argumentov
(define (At e ts) (list 'At e ts)) ; aplikácia funkcie

;; Predikáty.

(define (Vt? t) (equal? (list-ref t 0) 'Vt))
(define (Ct? t) (equal? (list-ref t 0) 'Ct))
(define (Pt? t) (equal? (list-ref t 0) 'Pt))
(define (At? t) (equal? (list-ref t 0) 'At))

;; Selektory.

(define (Vt-index t) (list-ref t 1))
(define (Ct-const t) (list-ref t 1))
(define (Pt-arg t) (list-ref t 1))
(define (Pt-args t) (list-ref t 2))
(define (At-fun t) (list-ref t 1))
(define (At-arg t) (list-ref t 2))

;; Údajový typ pre primitívne rekurzívne termy.

(define (TERM? t)
  (and (list? t)
       (>= (length t) 1)
       (or (and (Vt? t)
                (= (length t) 2)
                (natural-number? (Vt-index t)))
           (and (Ct? t)
                (= (length t) 2)
                (natural-number? (Ct-const t)))
           (and (Pt? t)
                (= (length t) 3)
                (TERM? (Pt-arg t))
                (TERM? (Pt-args t)))
           (and (At? t)
                (= (length t) 3)
                (PRFS? (At-fun t))
                (TERM? (At-arg t))))))

;; Predikát p.r.-term?(n,t) platí, ak číslo t je kódom nejakého p. r. termu
;; v prvých n premenných x₁,...,xₙ.

(define (p.r.-term? n t)
  (define (is-p.r.-term? n t)
    (or (and (Vt? t)
             (<= 1 (Vt-index t))
             (<= (Vt-index t) n))
        (Ct? t)
        (and (At? t)
             (let* ([e (At-fun t)] [m (arity e)])
                   (and (>= m 1)
                        (p.r.-function-symbol? m e)
                        (are-p.r.-terms? n (At-arg t) m))))))
  (define (are-p.r.-terms? n ts k)
    (or (and (= k 1)
             (is-p.r.-term? n ts))
        (and (> k 1)
             (Pt? ts)
             (is-p.r.-term? n (Pt-arg ts))
             (are-p.r.-terms? n (Pt-args ts) (- k 1)))))
  (and (TERM? t) (is-p.r.-term? n t)))

;; Úloha. Zostrojte program, ktorý počíta denotačnú funkciu den(t,v) pre
;; p. r. termy. Tu číslo v reprezentuje priradenie hodnôt premenným v terme t.

(define (den t v) ...)

;;; Podpodsekcia. Explicitné definície.

;; Úloha.
;; Zostrojte program pre funkciu xedf(n,t) takú, že pre každé n ≥ 1 platí:
;;   ak t je kódom p. r. termu τ v premenných x₁,...,xₙ, potom xedf(n,t) je dobre
;;   vytvorený p. r. index n-árnej funkcie f definovanej vzťahom
;;     f(x₁,...,xₙ) = τ[x₁,...,xₙ].

(define (xedf n t) ...)

;; Úloha. Zostrojte dobre vytvorený p. r. index xf(e1,e2,e3) pre funkciu f
;; definovanú vzťahom:
;;   f(x,y,z) = g3(x,g2(z,g1(x)),2)
;; Tu čísla e1, e2 a e3 sú dobre vytvorené p. r. indexy funkcií g1, g2 a g3.
;;   Pokyny. V implementácii využite operáciu xedf.

(define (xf e1 e2 e3) ...)

;; (PRFS? (xf (Ix 1 1) (Ix 2 1) (Ix 3 1)))
;; (p.r.-function-symbol? 3 (xf (Ix 1 1) (Ix 2 1) (Ix 3 1)))

;;; Podsekcia. Primitívne rekurzívne definície.

;; Úloha. Zostrojte dobre vytvorený p. r. index pre sčítanie.
;;   Pokyny. V implementácii využite operáciu xedf.

(define ⌜+⌝ ...)

;; (PRFS? ⌜+⌝)
;; (p.r.-function-symbol? 2 ⌜+⌝)
;; (query (λ (x) (interpreter ⌜+⌝ (cons x 5))) 0 10)

;; Úloha. Zostrojte dobre vytvorený p. r. index pre násobenie.
;;   Pokyny. V implementácii využite operáciu xedf.

(define ⌜×⌝ ...)

;; (PRFS? ⌜×⌝)
;; (p.r.-function-symbol? 2 ⌜×⌝)
;; (query (λ (x) (interpreter ⌜×⌝ (cons x 5))) 0 10)

;; Úloha. Zostrojte dobre vytvorený p. r. index pre operáciu umocňovania.
;;   Pokyny. V implementácii využite operáciu xedf.

(define ⌜exp⌝ ...)

;; (PRFS? ⌜exp⌝)
;; (p.r.-function-symbol? 2 ⌜exp⌝)
;; (query (λ (x) (interpreter ⌜exp⌝ (cons 2 x))) 0 10)
