#lang racket

;;;; 12. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 10.5.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované príprave na semestrálny test:
;;;; - kombinatorika na zoznamoch,
;;;; - primitívne rekurzívne indexy,
;;;; - imperatívne programovanie.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory maux*.rkt obsahujú definície pomocných funkcií a predikátov. 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;; Pozri tiež súbor priprava_na_test.txt

;; [Lisp]

(require racket/undefined)
(define ... undefined)
;; (define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

(require scheme/mpair)

(define (pair->mpair x)
  (if (pair? x)
      (mcons (pair->mpair (car x)) (pair->mpair (cdr x)))
      x))

;;; Kapitola. Imperatívne programovanie.

;;; Sekcia. Obecné stromy.

;; Príklad. Nasledujúci komponent obsahuje definiciu obecných stromov.

(define (tree? t)
  (define (forest? ts)
    (or (null? ts)
        (and (mpair? ts)
             (tree? (mcar ts))
             (forest? (mcdr ts)))))
  (and (mpair? t)
       (number? (mcar t))
       (forest? (mcdr t))))

;; (tree? (pair->mpair '(1)))
;; (tree? (pair->mpair '(1 (2) (3))))
;; (tree? (pair->mpair '(1 (2 (3)) (4 (5) (6) (7)) (8))))

;; Úloha. Zostrojte iteratívny program, ktorý vytvorí zrkadlový obraz stromu.
;;   Pokyny. Nepoužívajte operáciu reverse.

(define (reflect t) ...)

;; (reflect (pair->mpair '(1)))
;; (reflect (pair->mpair '(1 (2) (3))))
;; (reflect (pair->mpair '(1 (2 (3)) (4 (5) (6) (7)) (8))))

;; Úloha. Nájdite imperatívnu implementáciu predošlého programu, ktorá nevyužíva
;; konštruktor mcons.

(define (reflect! t) ...)

;; (let ([t (pair->mpair '(1))]) (writeln t) (writeln (reflect! t)) (writeln t))
;; (let ([t (pair->mpair '(1 (2) (3)))]) (writeln t) (writeln (reflect! t)) (writeln t))
;; (let ([t (pair->mpair '(1 (2 (3)) (4 (5) (6) (7)) (8)))]) (writeln t) (writeln (reflect! t)) (writeln t))

;; Úloha. Zostrojte program, ktorý nahradí uzly daného stromu číslami 1,2,3,...
;; v poradí, ktorý odpovedá spätnému prechodu stromom.

(define (postorder-numbering t1) ...)

;; (postorder-numbering (pair->mpair '(2)))
;; (postorder-numbering (pair->mpair '(2 (3) (5))))
;; (postorder-numbering (pair->mpair '(2 (3 (5)) (7 (11) (13) (17)) (19))))

;; Úloha. Nájdite imperatívnu implementáciu predošlého programu, ktorá nevyužíva
;; konštruktor mcons.

(define (postorder-numbering! t1) ...)

;; (let ([t (pair->mpair '(2))]) (writeln t) (writeln (postorder-numbering! t)) (writeln t))
;; (let ([t (pair->mpair '(2 (3) (5)))]) (writeln t) (writeln (postorder-numbering! t)) (writeln t))
;; (let ([t (pair->mpair '(2 (3 (5)) (7 (11) (13) (17)) (19)))]) (writeln t) (writeln (postorder-numbering! t)) (writeln t))
